package com.retrytech.deliveryboy.activites;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import com.google.firebase.iid.FirebaseInstanceId;
import com.retrytech.deliveryboy.R;
import com.retrytech.deliveryboy.SessionManager;
import com.retrytech.deliveryboy.databinding.ActivityLoginBinding;
import com.retrytech.deliveryboy.models.DeliveryBoyRoot;
import com.retrytech.deliveryboy.retrofit.Const;
import com.retrytech.deliveryboy.retrofit.RetrofitBuilder;
import com.retrytech.deliveryboy.retrofit.RetrofitService;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;


public class LoginActivity extends AppCompatActivity {
    ActivityLoginBinding binding;
    SessionManager sessionManager;
    private String token;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_login);
        sessionManager = new SessionManager(this);

        binding.tvvegi.setTransitionName(getIntent().getStringExtra("position"));
        initMain();
/*
        Call<SettingsRoot> call = RetrofitBuilder.create().getSettings(Const.DEV_KEY);
        call.enqueue(new Callback<SettingsRoot>() {
            @Override
            public void onResponse(Call<SettingsRoot> call, Response<SettingsRoot> response) {
                if (response.code() == 200) {
                    if (response.body().getStatus() == 200 && response.body().getData() != null) {
                        String curr = response.body().getData().getCurrency();
                        VegiUtils.setCurrency(curr);


                    } else {
                        Toast.makeText(LoginActivity.this, "Something went wrong", Toast.LENGTH_SHORT).show();
                    }
                } else {
                    Toast.makeText(LoginActivity.this, "Something went wrong", Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onFailure(Call<SettingsRoot> call, Throwable t) {
                Toast.makeText(LoginActivity.this, "Something went wrong", Toast.LENGTH_SHORT).show();
            }
        });
*/


    }

    private void initMain() {
        FirebaseInstanceId.getInstance().getInstanceId()
                .addOnCompleteListener(task -> {
                    if (!task.isSuccessful()) {
                        Log.w("notification", "getInstanceId failed", task.getException());
                        return;
                    }
                    // Get new Instance ID token
                    if (task.getResult() != null) {
                        token = task.getResult().getToken();
                        sessionManager.saveStringValue(Const.NOTIFICATION_TOKEN, token);
                        Log.d("notification", token);
                    }
                    // Log and toast
                });

        initListnear();


    }

    private void initListnear() {
        binding.tvSignup.setOnClickListener(v -> {
            if (binding.etUserName.getText().toString().equals("")) {
                Toast.makeText(this, getString(R.string.enterusername), Toast.LENGTH_SHORT).show();
                binding.etUserName.setError(getString(R.string.enterusername));
                return;
            }
            if (binding.etPassword.getText().toString().equals("")) {
                Toast.makeText(this, getString(R.string.enterpassword), Toast.LENGTH_SHORT).show();
                binding.etUserName.setError(getString(R.string.enterpassword));
                return;
            }
            RetrofitService service = RetrofitBuilder.create();
            binding.pd.setVisibility(View.VISIBLE);
            Call<DeliveryBoyRoot> call = service.login(Const.DEV_KEY, binding.etUserName.getText().toString(),
                    binding.etPassword.getText().toString(), "1", token);
            call.enqueue(new Callback<DeliveryBoyRoot>() {
                @Override
                public void onResponse(Call<DeliveryBoyRoot> call, Response<DeliveryBoyRoot> response) {
                    if (response.code() == 200) {
                        if (response.body().isStatus() && response.body().getData() != null) {
                            DeliveryBoyRoot data = response.body();
                            sessionManager.saveUser(data);
                            sessionManager.saveBooleanValue(Const.IS_LOGIN, true);
                           // Toast.makeText(LoginActivity.this, data.getData().getFullname(), Toast.LENGTH_SHORT).show();
                            startActivity(new Intent(LoginActivity.this, MainActivity.class));

                        } else {
                            Toast.makeText(LoginActivity.this, response.body().getMessage(), Toast.LENGTH_SHORT).show();
                        }
                    }
                    binding.pd.setVisibility(View.GONE);
                }

                @Override
                public void onFailure(Call<DeliveryBoyRoot> call, Throwable t) {
// dd
                }
            });

        });

    }
}