package com.retrytech.deliveryboy.activites;

import android.Manifest;
import android.app.Activity;
import android.content.Context;
import android.content.pm.PackageManager;
import android.content.res.ColorStateList;
import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Color;
import android.location.Location;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Looper;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import androidx.databinding.DataBindingUtil;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.DataSource;
import com.bumptech.glide.load.engine.GlideException;
import com.bumptech.glide.request.RequestListener;
import com.bumptech.glide.request.target.Target;
import com.google.android.gms.location.FusedLocationProviderClient;
import com.google.android.gms.location.LocationCallback;
import com.google.android.gms.location.LocationRequest;
import com.google.android.gms.location.LocationResult;
import com.google.android.gms.location.LocationServices;
import com.google.android.gms.location.LocationSettingsRequest;
import com.google.android.gms.location.LocationSettingsResponse;
import com.google.android.gms.location.SettingsClient;
import com.google.android.gms.maps.CameraUpdateFactory;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.OnMapReadyCallback;
import com.google.android.gms.maps.SupportMapFragment;
import com.google.android.gms.maps.model.BitmapDescriptorFactory;
import com.google.android.gms.maps.model.LatLng;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.maps.model.PolylineOptions;
import com.google.android.gms.tasks.Task;
import com.google.android.material.bottomsheet.BottomSheetBehavior;
import com.google.android.material.bottomsheet.BottomSheetDialog;
import com.google.gson.Gson;
import com.retrytech.deliveryboy.DirectionsJSONParser;
import com.retrytech.deliveryboy.R;
import com.retrytech.deliveryboy.SessionManager;
import com.retrytech.deliveryboy.VegiUtils;
import com.retrytech.deliveryboy.adapters.OrderItemAdapter;
import com.retrytech.deliveryboy.databinding.ActivityOrderDetailBinding;
import com.retrytech.deliveryboy.databinding.BottomSheetorderdetailBinding;
import com.retrytech.deliveryboy.models.OrderDetailRoot;
import com.retrytech.deliveryboy.models.RestResponse;
import com.retrytech.deliveryboy.models.User;
import com.retrytech.deliveryboy.popups.CompleteOrderPopup;
import com.retrytech.deliveryboy.popups.HoldPopup;
import com.retrytech.deliveryboy.retrofit.Const;
import com.retrytech.deliveryboy.retrofit.RetrofitBuilder;
import com.retrytech.deliveryboy.retrofit.RetrofitService;

import org.jetbrains.annotations.NotNull;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import de.hdodenhof.circleimageview.CircleImageView;
import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class OrderDetailActivity extends AppCompatActivity implements OnMapReadyCallback {
    private static final String TAG = "orderdetailmap ";
    private static final int PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION = 1000;
    ActivityOrderDetailBinding binding;
    SessionManager sessionManager;
    int i = 0;
    BottomSheetDialog bottomSheetDialog;
    BottomSheetorderdetailBinding sheetbinding;
    GoogleMap map;
    ArrayList<LatLng> markerPoints;
    SupportMapFragment fm;
    boolean imageCreated = false;
    Bitmap bmp = null;
    Marker currentLocationMarker;
    private String token;
    private OrderDetailRoot.Data data;
    private RetrofitService service;


    private String turnongps = "Turn On GPS";
    private User user;
    private OrderDetailRoot.Orderaddress address;
    private LocationCallback locationCallback;
    private FusedLocationProviderClient fusedLocationClient;
    private boolean locationFetched = false;
    private DecimalFormat df;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_order_detail);
        sessionManager = new SessionManager(this);
        service = RetrofitBuilder.create();
        df = new DecimalFormat("###.##");
        bottomSheetDialog = new BottomSheetDialog(this);
        String oid = getIntent().getStringExtra("oid");
        String from = getIntent().getStringExtra("from");
        String userStr = getIntent().getStringExtra("user");
        if (userStr != null && !userStr.isEmpty()) {
            user = new Gson().fromJson(userStr, User.class);

        }
        if (from != null && !from.equals("") && from.equals("complete")) {
            binding.cardview.setVisibility(View.GONE);
        }
        if (sessionManager.getBooleanValue(Const.IS_LOGIN)) {
            token = sessionManager.getUser().getData().getToken();
            getData(oid);
        }


    }

    private void getData(String oid) {
        binding.pd.setVisibility(View.VISIBLE);
        Call<OrderDetailRoot> call = service.getOrdersDetail(Const.DEV_KEY, token, oid);
        call.enqueue(new Callback<OrderDetailRoot>() {
            @Override
            public void onResponse(Call<OrderDetailRoot> call, Response<OrderDetailRoot> response) {
                if (response.code() == 200 && response.body().isStatus() && response.body().getData() != null) {
                    data = response.body().getData();

                    setData();

                    manageStatus();


                }
                binding.pd.setVisibility(View.GONE);
            }

            @Override
            public void onFailure(Call<OrderDetailRoot> call, Throwable t) {
//ll
            }
        });
    }

    private void manageStatus() {
        if (data.getStatus() == 1) {

        } else if (data.getStatus() == 2) {
            binding.lytStart.setVisibility(View.VISIBLE);
        } else if (data.getStatus() == 3) {

        } else if (data.getStatus() == 4) {

        } else if (data.getStatus() == 5) {

        }
        if (data.getStartDelivery() == 6) {
            binding.lytCompleteHold.setVisibility(View.VISIBLE);
            binding.lytStart.setVisibility(View.GONE);
        } else {
            //  binding.lytStart.setVisibility(View.VISIBLE);
        }
    }

    private void setData() {

        // set User data
        if (user != null) {

            Glide.with(binding.getRoot().getContext())
                    .load(Const.BASE_IMG_URL + user.getImage())
                    .placeholder(R.drawable.user_place_holder)
                    .error(R.drawable.user_place_holder)
                    .circleCrop()
                    .into(binding.imgUser);
        }

        //  setBottomSheet();
        binding.tvorderid.setText(data.getOrderId());
        binding.tvOrderid.setText(data.getOrderId());
        if (data.getOrderaddress() != null) {

            if (data.getOrderaddress().getLatitude() != null && data.getStatus() != 4) {
                getLocationPermission();
            } else {
                if (data.getStatus() == 4) {
                    binding.tvLocation.setText("Order Delivered");
                }
                bottomSheetDialog.setCancelable(false);
                binding.lytNoLocation.setVisibility(View.VISIBLE);
            }

            try {
                Log.d(TAG, "onResponse: lat  " + data.getOrderaddress().getLatitude());
            } catch (Exception e) {
                Log.d(TAG, "setData: location lat not");
                e.printStackTrace();
            }

            address = data.getOrderaddress();
            binding.tvName.setText(address.getFirstname());
            binding.tvCustomerName.setText(address.getFirstname());
            binding.tvaddress1.setText(address.getArea().concat(", ").concat(address.getCity()));
            binding.tvaddress2.setText(address.getAddressLine()
                    + " \n" + address.getArea() + " " + address.getLandmark() + " " + address.getPincode());
            binding.tvMobile.setText(address.getNumber());

            binding.tvdeliverytype.setText(VegiUtils.getDeliveryType(data.getPaymentType()));
            binding.tvdeliverytype.setBackgroundTintList(ColorStateList.valueOf(ContextCompat.getColor(this, data.getPaymentType() == 1 ? R.color.color_orange : R.color.green)));

        }
        if (data.getOrderproducts() != null) {
            OrderItemAdapter orderItemAdapter = new OrderItemAdapter(data.getOrderproducts());
            binding.rvorderitems.setAdapter(orderItemAdapter);
        }
        if (data.getShippingCharge() != null) {
            binding.tvshippingcharge.setText(VegiUtils.getCurrency().concat(String.valueOf(df.format(Float.parseFloat(data.getShippingCharge())))));
        }
        binding.tvprice.setText(VegiUtils.getCurrency().concat(df.format(Float.parseFloat(data.getTotalAmount()))));

        setBottomSheet();
        initListnear();
    }


    private void initMap() {

        markerPoints = new ArrayList<>();
        // Getting reference to SupportMapFragment of the activity_main
        fm = (SupportMapFragment) getSupportFragmentManager().findFragmentById(R.id.map);
        fm.getMapAsync(this);


    }


    private void getLocationPermission() {

        if (ContextCompat.checkSelfPermission(this.getApplicationContext(),
                android.Manifest.permission.ACCESS_FINE_LOCATION)
                == PackageManager.PERMISSION_GRANTED) {

            initMap();
        } else {
            ActivityCompat.requestPermissions(this,
                    new String[]{android.Manifest.permission.ACCESS_FINE_LOCATION},
                    PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION);
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           @NonNull String[] permissions,
                                           @NonNull int[] grantResults) {

        // If request is cancelled, the result arrays are empty.
        if (requestCode == PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION && grantResults.length > 0
                && grantResults[0] == PackageManager.PERMISSION_GRANTED) {

            updateLocationUI();
        }
    }

    public void createCustomMarker(Context context, String resource, String name, LatLng destlatlang) {

        View marker = ((LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE)).inflate(R.layout.custom_marker_layout, null);

        CircleImageView markerImage = (CircleImageView) marker.findViewById(R.id.user_dp);
        Log.d(TAG, "createCustomMarker: " + resource);
        Glide.with(context)
                .asBitmap()
                .load(Const.BASE_IMG_URL + resource)
                .placeholder(R.drawable.user_place_holder)
                .error(R.drawable.user_place_holder)
                .addListener(new RequestListener<Bitmap>() {
                    @Override
                    public boolean onLoadFailed(@Nullable GlideException e, Object model, Target<Bitmap> target, boolean isFirstResource) {
                        return false;
                    }

                    @Override
                    public boolean onResourceReady(Bitmap resource, Object model, Target<Bitmap> target, DataSource dataSource, boolean isFirstResource) {
                        TextView textView = (TextView) marker.findViewById(R.id.name);
                        textView.setText(name);
                        markerImage.setImageBitmap(resource);
                        DisplayMetrics displayMetrics = new DisplayMetrics();
                        ((Activity) context).getWindowManager().getDefaultDisplay().getMetrics(displayMetrics);
                        marker.setLayoutParams(new ViewGroup.LayoutParams(52, ViewGroup.LayoutParams.WRAP_CONTENT));
                        marker.measure(displayMetrics.widthPixels, displayMetrics.heightPixels);
                        marker.layout(0, 0, displayMetrics.widthPixels, displayMetrics.heightPixels);
                        marker.buildDrawingCache();
                        Bitmap bitmap = Bitmap.createBitmap(marker.getMeasuredWidth(), marker.getMeasuredHeight(), Bitmap.Config.ARGB_8888);
                        Canvas canvas = new Canvas(bitmap);
                        marker.draw(canvas);
                        OrderDetailActivity.this.map.addMarker(new MarkerOptions()
                                .position(destlatlang)
                                .title(address.getFirstname())
                                .icon(BitmapDescriptorFactory.fromBitmap(bitmap)));
                        return false;
                    }
                })
                .circleCrop().into(markerImage);


    }


    private void setBottomSheet() {

        BottomSheetBehavior<LinearLayout> sheetBehavior = BottomSheetBehavior.from(binding.continerlyt);
        sheetBehavior.setFitToContents(false);
        sheetBehavior.setHideable(false);//prevents the boottom sheet from completely hiding off the screen
        sheetBehavior.setState(BottomSheetBehavior.STATE_EXPANDED);

        binding.arrowicon.setRotation(90);
        binding.arrowicon.setOnClickListener(v -> {
            if (sheetBehavior.getState() == BottomSheetBehavior.STATE_EXPANDED) {
                sheetBehavior.setState(BottomSheetBehavior.STATE_COLLAPSED);
                binding.arrowicon.setRotation(-90);
            } else {
                sheetBehavior.setState(BottomSheetBehavior.STATE_EXPANDED);
                binding.arrowicon.setRotation(90);
            }
        });
        sheetBehavior.setBottomSheetCallback(new BottomSheetBehavior.BottomSheetCallback() {
            @Override
            public void onStateChanged(@NonNull View bottomSheet, int newState) {

            }

            @Override
            public void onSlide(@NonNull View bottomSheet, float slideOffset) {

            }
        });

        sheetBehavior.setBottomSheetCallback(new BottomSheetBehavior.BottomSheetCallback() {
            @Override
            public void onStateChanged(@NonNull View bottomSheet, int newState) {
                if (newState == BottomSheetBehavior.STATE_COLLAPSED) {
                    binding.arrowicon.setRotation(-90);
                } else if (newState == BottomSheetBehavior.STATE_EXPANDED) {
                    binding.arrowicon.setRotation(90);
                } else if (newState == BottomSheetBehavior.STATE_HALF_EXPANDED) {
                    binding.arrowicon.setRotation(90);
                }
            }

            @Override
            public void onSlide(@NonNull View bottomSheet, float slideOffset) {
//ll
            }
        });
    }

    private void initListnear() {
        binding.tvStart.setOnClickListener(v -> startDelivery());
        binding.tvComplete.setOnClickListener(v -> {
            CompleteOrderPopup completeOrderPopup = new CompleteOrderPopup(this, data, new CompleteOrderPopup.OnCompletePopupClickListnear() {
                @Override
                public void onComplete() {
                    completeOrder();
                }
            });
        });
        binding.tvHold.setOnClickListener(v -> {
            HoldPopup holdPopup = new HoldPopup(OrderDetailActivity.this, new HoldPopup.OnHoldPopupClickListner() {
                @Override
                public void onClickHold(String i) {
                    holdOrder(i);
                }
            });
        });

    }


    private void holdOrder(String i) {
        binding.pd.setVisibility(View.VISIBLE);
        Call<RestResponse> call = service.onHoldDelivery(Const.DEV_KEY, token, data.getOrderId(), String.valueOf(i));
        call.enqueue(new Callback<RestResponse>() {
            @Override
            public void onResponse(Call<RestResponse> call, Response<RestResponse> response) {
                if (response.code() == 200 && response.body().isStatus()) {
                    Log.d(TAG, "onResponse: hold");
                    Toast.makeText(OrderDetailActivity.this, "order is on hold", Toast.LENGTH_SHORT).show();
                    finish();
                }
                binding.pd.setVisibility(View.GONE);
            }

            @Override
            public void onFailure(Call<RestResponse> call, Throwable t) {
//ll
            }
        });

    }

    private void startDelivery() {
        binding.pd.setVisibility(View.VISIBLE);
        Call<RestResponse> call = service.startDelivery(Const.DEV_KEY, token, data.getOrderId());
        call.enqueue(new Callback<RestResponse>() {
            @Override
            public void onResponse(Call<RestResponse> call, Response<RestResponse> response) {
                if (response.code() == 200 && response.body().isStatus()) {
                    Toast.makeText(OrderDetailActivity.this, "Delivery Started", Toast.LENGTH_SHORT).show();
                    binding.lytCompleteHold.setVisibility(View.VISIBLE);
                    binding.lytStart.setVisibility(View.GONE);
                }
                binding.pd.setVisibility(View.GONE);
            }

            @Override
            public void onFailure(Call<RestResponse> call, Throwable t) {
//ll
            }
        });
    }


    private String getDirectionsUrl(LatLng origin, LatLng dest) {

        // Origin of route
        String strOrigin = "origin=" + origin.latitude + "," + origin.longitude;
        Log.d(TAG, "getDirectionsUrl: start==" + strOrigin);
        // Destination of route
        String strDest = "destination=" + dest.latitude + "," + dest.longitude;
        Log.d(TAG, "getDirectionsUrl: end==" + strDest);
        // Sensor enabled
        String sensor = "sensor=false";

        // Waypoints
        StringBuilder waypoints = new StringBuilder();
        for (int i = 2; i < markerPoints.size(); i++) {
            LatLng point = markerPoints.get(i);
            if (i == 2)
                waypoints = new StringBuilder("waypoints=");
            waypoints.append(point.latitude).append(",").append(point.longitude).append("|");
        }

        // Building the parameters to the web service
        String parameters = strOrigin + "&" + strDest + "&" + sensor + "&" + waypoints + "&key=" + getString(R.string.map_api_key);

        // Output format
        String output = "json";

        // Building the url to the web service
        String url = "https://maps.googleapis.com/maps/api/directions/" + output + "?" + parameters;
        Log.d(TAG, "getDirectionsUrl: url =" + url);
        return url;
    }

    /**
     * A method to download json data from url
     */

    private void updateLocationUI() {
        Log.d(TAG, "updateLocationUI: ");
        if (map == null) {
            return;
        }
        Log.d(TAG, "updateLocationUI: 2");
        try {
            fusedLocationClient = LocationServices.getFusedLocationProviderClient(this);
            map.setMyLocationEnabled(true);
            map.getUiSettings().setMyLocationButtonEnabled(true);
            map.setOnMyLocationClickListener(new GoogleMap.OnMyLocationClickListener() {
                @Override
                public void onMyLocationClick(@NonNull @NotNull Location location) {
                    map.moveCamera(CameraUpdateFactory.newLatLngZoom(
                            new LatLng(location.getLatitude(),
                                    location.getLongitude()), 14));

                }
            });
            getDeviceLocation();
           /* if (locationPermissionGranted) {

            } else {
                map.setMyLocationEnabled(false);
                map.getUiSettings().setMyLocationButtonEnabled(false);
                lastKnownLocation = null;
                getLocationPermission();
            }*/
        } catch (SecurityException e) {
            Log.e(TAG, e.getMessage());
        }
    }

    private void getDeviceLocation() {
        /*
         * Get the best and most recent location of the device, which may be null in rare
         * cases when a location is not available.
         */
        try {


            locationCallback = new LocationCallback() {
                @Override
                public void onLocationResult(LocationResult locationResult) {
                    if (locationResult == null) {
                        map.getUiSettings().setMyLocationButtonEnabled(false);

                        return;
                    }
                    for (Location location : locationResult.getLocations()) {
                        // Update UI with location data
                        Log.d(TAG, "onLocationResult: " + location.getLatitude());


                        if (!locationFetched) {
                            Log.d("TAG ORDER", "onLocationResult: =====>>  " + location.getLatitude() + " " + location.getLongitude());
                            locationFetched = true;
                            //   lastKnownLocation.setLatitude(location.getLatitude());
                            //   lastKnownLocation.setLongitude(location.getLongitude());
                            map.moveCamera(CameraUpdateFactory.newLatLngZoom(
                                    new LatLng(location.getLatitude(),
                                            location.getLongitude()), 14));

                            setUpMapRoute(location);
                        }

                        // ...
                    }


                }
            };
            LocationRequest locationRequest = LocationRequest.create();
            locationRequest.setInterval(10000);
            locationRequest.setFastestInterval(5000);
            locationRequest.setPriority(LocationRequest.PRIORITY_HIGH_ACCURACY);

            LocationSettingsRequest.Builder builder = new LocationSettingsRequest.Builder()
                    .addLocationRequest(locationRequest);

            SettingsClient client = LocationServices.getSettingsClient(this);
            Task<LocationSettingsResponse> task = client.checkLocationSettings(builder.build());
            fusedLocationClient.requestLocationUpdates(locationRequest,
                    locationCallback,
                    Looper.getMainLooper());


        } catch (SecurityException e) {
            Log.e(TAG, e.getMessage(), e);
        }
    }

    @Override
    public void onMapReady(GoogleMap googleMap) {
        Log.d(TAG, "onMapReady: " + googleMap.toString());
        map = googleMap;

        updateLocationUI();


        // Get the current location of the device and set the position of the map.


    }

    private void completeOrder() {
        binding.pd.setVisibility(View.VISIBLE);
        Call<RestResponse> call = service.completeDelivery(Const.DEV_KEY, token, data.getOrderId(), data.getTotalAmount());
        call.enqueue(new Callback<RestResponse>() {
            @Override
            public void onResponse(Call<RestResponse> call, Response<RestResponse> response) {
                if (response.code() == 200 && response.body().isStatus()) {
                    Log.d(TAG, "onResponse: colplere");
                    Toast.makeText(OrderDetailActivity.this, "Completed", Toast.LENGTH_SHORT).show();

                    finish();
                }
                binding.pd.setVisibility(View.GONE);
            }

            @Override
            public void onFailure(Call<RestResponse> call, Throwable t) {
//ll
            }
        });

    }

    private void setUpMapRoute(Location lastKnownLocation) {
        if (map != null) {
            if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
                return;
            }


            Log.d(TAG, "onCreate: map is not null ");
            map.setMyLocationEnabled(true);

            // Setting onclick event listener for the map

            // The map will be cleared on long click
//            binding.pd.setVisibility(View.VISIBLE);
            if (lastKnownLocation == null) {
                //  Toast.makeText(this, getString(R.string.unknown), Toast.LENGTH_SHORT).show();
                Toast.makeText(OrderDetailActivity.this, turnongps, Toast.LENGTH_SHORT).show();
                Log.d(TAG, "setUpMapRoute: last loc is null");
                return;
            }

            LatLng mylatlang = new LatLng(lastKnownLocation.getLatitude(), lastKnownLocation.getLongitude());

            if (address != null && address.getLongitude() != null && address.getLatitude() != null) {
                if (!address.getLatitude().equals("") && !address.getLongitude().equals("")) {
                    LatLng destlatlang = new LatLng(Double.parseDouble(address.getLatitude()), Double.parseDouble(address.getLongitude()));
                    markerPoints.add(mylatlang);
                    markerPoints.add(destlatlang);


                    createCustomMarker(this, user.getImage(), address.getFirstname(), destlatlang);
                    Log.d(TAG, "onMapReady: desti " + address.getLatitude());
                    Log.d(TAG, "onMapReady: size " + markerPoints.size());
                    if (markerPoints.size() >= 2) {
//                        binding.pd.setVisibility(View.VISIBLE);

                        LatLng origin = markerPoints.get(0);
                        LatLng dest = markerPoints.get(1);

                        // Getting URL to the Google Directions API
                        String url = getDirectionsUrl(origin, dest);

                        DownloadTask downloadTask = new DownloadTask();

                        // Start downloading json data from Google Directions API
                        downloadTask.execute(url);
                    }
                } else {
                    binding.pd.setVisibility(View.GONE);
                    Toast.makeText(this, getString(R.string.customeraddressnotfound), Toast.LENGTH_SHORT).show();
                }
            } else {
                binding.pd.setVisibility(View.GONE);
                Toast.makeText(this, getString(R.string.customeraddressnotfound), Toast.LENGTH_SHORT).show();
            }
            // Click event handler for Button btn_draw

        } else {
            Log.d(TAG, "onCreate: map not ready");
            fm.getMapAsync(this);
        }
    }

    public void onclickBack(View view) {
        onBackPressed();
    }


    // Fetches data from url passed
    @Deprecated
    private class DownloadTask extends AsyncTask<String, Void, String> {

        // Downloading data in non-ui thread
        @Override
        protected String doInBackground(String... url) {

            // For storing data1 from web service
            Log.d(TAG, "doInBackground: ");
            String data1 = "";

            try {
                // Fetching the data1 from web service
                data1 = downloadUrl(url[0]);
            } catch (Exception e) {
                binding.pd.setVisibility(View.GONE);
                Log.d("TAG Background Task", e.toString());
            }
            return data1;
        }

        // Executes in UI thread, after the execution of
        // doInBackground()
        @Deprecated
        @Override
        protected void onPostExecute(String result) {
            super.onPostExecute(result);
            Log.d(TAG, "onPostExecute: ");
            ParserTask parserTask = new ParserTask();
            binding.pd.setVisibility(View.GONE);
            // Invokes the thread for parsing the JSON data
            parserTask.execute(result);
        }

        private String downloadUrl(String strUrl) throws IOException {
            Log.d(TAG, "downloadUrl: " + strUrl);
            String data1 = "";
            InputStream iStream = null;
            HttpURLConnection urlConnection = null;
            try {
                URL url = new URL(strUrl);

                // Creating an http connection to communicate with url
                urlConnection = (HttpURLConnection) url.openConnection();

                // Connecting to url
                urlConnection.connect();

                // Reading data1 from url
                iStream = urlConnection.getInputStream();

                BufferedReader br = new BufferedReader(new InputStreamReader(iStream));

                StringBuilder sb = new StringBuilder();

                String line = "";
                while ((line = br.readLine()) != null) {
                    sb.append(line);
                }

                data1 = sb.toString();

                br.close();

            } catch (Exception e) {
                Log.d("TAG  222Exception", e.toString());
            } finally {
                if (iStream != null) {
                    iStream.close();
                    urlConnection.disconnect();
                }
            }
            return data1;
        }

    }

    private class ParserTask extends AsyncTask<String, Integer, List<List<HashMap<String, String>>>> {

        // Parsing the data in non-ui thread
        @Override
        protected List<List<HashMap<String, String>>> doInBackground(String... jsonData) {

            JSONObject jObject;
            List<List<HashMap<String, String>>> routes = null;

            try {
                jObject = new JSONObject(jsonData[0]);
                DirectionsJSONParser parser = new DirectionsJSONParser();

                // Starts parsing data
                routes = parser.parse(jObject);
            } catch (Exception e) {
                binding.pd.setVisibility(View.GONE);
                Log.d(TAG, "doInBackground: err286  " + e.toString());
                e.printStackTrace();
            }
            return routes;
        }

        // Executes in UI thread, after the parsing process
        @Deprecated
        @Override
        protected void onPostExecute(List<List<HashMap<String, String>>> result) {
            Log.d(TAG, "onPostExecute: ");
            ArrayList<LatLng> points = null;
            PolylineOptions lineOptions = null;
            binding.pd.setVisibility(View.GONE);
            // Traversing through all the routes
            if (result != null) {
                if (!result.isEmpty()) {
                    for (int i = 0; i < result.size(); i++) {
                        points = new ArrayList<>();
                        lineOptions = new PolylineOptions();

                        // Fetching i-th route
                        List<HashMap<String, String>> path = result.get(i);
                        Log.d(TAG, "onPostExecute: path " + path.toString());
                        // Fetching all the points in i-th route
                        for (int j = 0; j < path.size(); j++) {
                            HashMap<String, String> point = path.get(j);
                            Log.d(TAG, "onPostExecute: point " + point.toString());
                            double lat = Double.parseDouble(point.get("lat"));
                            double lng = Double.parseDouble(point.get("lng"));
                            LatLng position = new LatLng(lat, lng);

                            points.add(position);
                        }
                        Log.d(TAG, "onPostExecute: points size " + points.size());
                        // Adding all the points in the route to LineOptions
                        lineOptions.addAll(points);
                        lineOptions.width(8);
                        lineOptions.color(Color.BLACK);
                        Log.d(TAG, "onPostExecute: line options " + lineOptions.toString());
                    }

                    // Drawing polyline in the Google Map for the i-th route
                    map.addPolyline(lineOptions);
                    Log.d(TAG, "onPostExecute: 2");
                    binding.pd.setVisibility(View.GONE);
                } else {
                    Log.d(TAG, "onPostExecute: result is null " + result);
                }
            } else {
                Log.d(TAG, "onPostExecute: result is null " + result);
            }
        }
    }


}