package com.retrytech.deliveryboy.activites;

import android.app.ActivityOptions;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.util.Pair;
import android.view.View;
import android.view.WindowManager;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.databinding.DataBindingUtil;

import com.retrytech.deliveryboy.R;
import com.retrytech.deliveryboy.SessionManager;
import com.retrytech.deliveryboy.VegiUtils;
import com.retrytech.deliveryboy.databinding.ActivitySpleshBinding;
import com.retrytech.deliveryboy.models.SettingRoot;
import com.retrytech.deliveryboy.retrofit.Const;
import com.retrytech.deliveryboy.retrofit.RetrofitBuilder;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;

public class SpleshActivity extends AppCompatActivity {
    ActivitySpleshBinding binding;
    private SessionManager sessionManager;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN,
                WindowManager.LayoutParams.FLAG_FULLSCREEN);
        binding = DataBindingUtil.setContentView(this, R.layout.activity_splesh);


        Call<SettingRoot> call = RetrofitBuilder.create().getSetting(Const.DEV_KEY);
        call.enqueue(new Callback<SettingRoot>() {
            @Override
            public void onResponse(Call<SettingRoot> call, Response<SettingRoot> response) {
                if (response.code() == 200) {
                    if (response.body().isStatus() && response.body().getData() != null) {
                        String curr = response.body().getData().getCurrencies();
                        VegiUtils.setCurrency(curr);


                    } else {
                        Toast.makeText(SpleshActivity.this, "Something went wrong", Toast.LENGTH_SHORT).show();
                    }
                } else if (response.code() == 401) {

                    Toast.makeText(SpleshActivity.this, "Something went wrong", Toast.LENGTH_SHORT).show();
                }
            }

            @Override
            public void onFailure(Call<SettingRoot> call, Throwable t) {
                Toast.makeText(SpleshActivity.this, "Something went wrong", Toast.LENGTH_SHORT).show();
            }
        });


        sessionManager = new SessionManager(this);
        new Handler(Looper.myLooper()).postDelayed(() -> {
            if (sessionManager.getBooleanValue(Const.IS_LOGIN)) {
                startActivity(new Intent(SpleshActivity.this, MainActivity.class));

            } else {
                Pair[] pairs = new Pair[1];
                pairs[0] = new Pair<View, String>(binding.img, String.valueOf(0));
                ActivityOptions activityOptions = ActivityOptions.makeSceneTransitionAnimation(SpleshActivity.this, pairs);
                startActivity(new Intent(SpleshActivity.this, LoginActivity.class).putExtra("position", String.valueOf(0)), activityOptions.toBundle());
            }
        }, 1000);
    }
}