package com.retrytech.deliveryboy.popups;

import android.app.Dialog;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.Window;

import androidx.databinding.DataBindingUtil;

import com.retrytech.deliveryboy.R;
import com.retrytech.deliveryboy.VegiUtils;
import com.retrytech.deliveryboy.databinding.PopUpCompleteorderBinding;
import com.retrytech.deliveryboy.models.OrderDetailRoot;

import java.text.DecimalFormat;

import static android.content.Context.LAYOUT_INFLATER_SERVICE;

public class CompleteOrderPopup {
    public CompleteOrderPopup(Context context, OrderDetailRoot.Data data, OnCompletePopupClickListnear onCompletePopupClickListnear) {
        LayoutInflater inflater = (LayoutInflater) context.getSystemService(LAYOUT_INFLATER_SERVICE);
        PopUpCompleteorderBinding completePopupbinding = DataBindingUtil.inflate(inflater, R.layout.pop_up_completeorder, null, false);
        Dialog dialog = new Dialog(context, R.style.customStyle);
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);

        dialog.setContentView(completePopupbinding.getRoot());
        DecimalFormat df = new DecimalFormat("###.##");
        completePopupbinding.tvdeliverytype.setText(VegiUtils.getDeliveryType(data.getPaymentType()));
        completePopupbinding.tvPrice.setText(VegiUtils.currency + String.valueOf(df.format(Float.parseFloat(data.getTotalAmount()))));
        if (data.getPaymentType() == 1) {
            completePopupbinding.tvDes.setText(context.getString(R.string.popupdes));
        } else if (data.getPaymentType() == 2) {
            completePopupbinding.tvDes.setText(context.getString(R.string.popupdes2));

        }
        completePopupbinding.tvPositive.setOnClickListener(v -> {
            onCompletePopupClickListnear.onComplete();
        });
        completePopupbinding.tvCencel.setOnClickListener(v -> dialog.dismiss());


        dialog.show();
    }

    public interface OnCompletePopupClickListnear {
        void onComplete();
    }
}
